PROGRAM compare (input,x,y,output);

      {To compare two files and report differences}
      {Version for QDOS;  11 April 1986}

LABEL  1,99;

TYPE  byte = 0..255;
      para = ARRAY [0..15] OF byte;
      xbuffer = ARRAY [0..255] OF para;

VAR   x,y: FILE OF byte;
      fname: string[36];
      pxb: ^xbuffer;
      xcount,ycount: integer;
      blockno: 0..9999;
      xpc,xpmax: 0..256;
      xpara,ypara: para;
      gi: 0..15;
      printable: SET OF char;
      noerrors: boolean;

PROCEDURE writehex (fbyte: byte);
       {Output fbyte as two hex digits}
  VAR  nibh,nibl: 0..15;
  BEGIN
    nibh := fbyte DIV 16;
    nibl := fbyte MOD 16;
    IF nibh > 9 THEN write (chr (nibh - 10 + ord('A')))
    ELSE write (chr (nibh + ord('0')));
    IF nibl > 9 THEN write (chr (nibl - 10 + ord('A')))
    ELSE write (chr (nibl + ord('0')));
  END  {writehex};

PROCEDURE dumppara (VAR fpara: para);
       {Output fpara in hex and character form}
  VAR  i: 0..15;  lb: byte;  lstr: string[16];
  BEGIN
    writeln;  lstr := '';
    FOR i := 0 TO 15 DO
      BEGIN
        lb := fpara[i];
        write(' ');  writehex (lb);
        IF chr (lb) IN printable
        THEN lstr := concat (lstr,chr(lb))
        ELSE lstr := concat (lstr,'.');
      END;
    writeln (' ':5,lstr);
  END {dumpsector};

PROCEDURE report;
       {Display xpara,ypara and query continuation}
  VAR  bytenumber: integer;  hexval: 0..0FFFFH;
       i: 0..15;  ch: char;
  BEGIN
    writeln;
    bytenumber := blockno * 4096 + xpc * 16 + gi;
    write ('Difference in byte ',bytenumber:1,'  (hex ');
    hexval := bytenumber DIV 10000H;
    IF hexval <> 0 THEN
      BEGIN
        writehex (hexval DIV 100H);  writehex (hexval MOD 100H);
        write (' ');
      END;
    hexval := bytenumber MOD 10000H;
    writehex (hexval DIV 100H);  writehex (hexval MOD 100H);
    writeln (')');
    dumppara (xpara);  dumppara (ypara);
    FOR i := 0 TO 15 DO
      IF ypara[i] = xpara[i] THEN write ('   ')
      ELSE write ('  ^');
    writeln;

    REPEAT
      writeln;
      write ('Continue ? - ');  readln (ch);
      IF ch IN ['N','n'] THEN GOTO 99;
    UNTIL ch IN ['Y','y'];
  END  {report};

BEGIN
  write ('Filename 1: ');  readln (fname);
  assign (x,fname);  reset (x);

  write ('Filename 2: ');  readln (fname);
  assign (y,fname);  reset (y);

  new (pxb);
  xcount := 0;  ycount := 0;
  blockno := 0;
  printable := ['0'..'9','A'..'Z','a'..'z',
                ' ','!','"','#','$','%','&','''','(',')',
                '*','+',',','-','.','/',
                ':',';','<','=','>','?','@',
                '[','\',']','_'];
  noerrors := true;

  REPEAT
    xpmax := 0;
    WHILE NOT eof (x) AND (xpmax < 256) DO
      BEGIN     {read from file x and store in pxb^}
        FOR gi := 0 TO 15 DO
          IF eof (x) THEN xpara[gi] := 0
          ELSE
            BEGIN
              read (x,xpara[gi]);  xcount := xcount + 1;
            END;
        pxb^[xpmax] := xpara;  xpmax := xpmax + 1;
      END;
    xpc := 0;
    WHILE NOT eof (y) AND (xpc < xpmax) DO
      BEGIN    {read from y and compare with stored values}
        FOR gi := 0 TO 15 DO
          IF eof (y) THEN ypara[gi] := 0
          ELSE
            BEGIN
              read (y,ypara[gi]);  ycount := ycount + 1;
            END;
        xpara := pxb^[xpc];
        FOR gi := 0 TO 15 DO
          IF ypara[gi] <> xpara[gi] THEN
            BEGIN
              report;  noerrors := false;  GOTO 1;
            END;
      1:  xpc := xpc + 1;
      END;
    blockno := blockno + 1;
  UNTIL (eof(x) OR eof(y));

  writeln;
  IF noerrors THEN writeln ('No differences');
  IF eof (x) AND eof (y) AND (xcount = ycount)
  THEN writeln ('Lengths are equal')
  ELSE
  IF NOT eof (y) THEN writeln ('File 2 is longer')
  ELSE writeln ('File 1 is longer');

99:
END.
